io.vertx.rxjava3.ext.web.openapi.router

## Class RouterBuilder

- java.lang.Object
- - io.vertx.rxjava3.ext.web.openapi.router.RouterBuilder

-     public class RouterBuilder
      extends Object

  Interface to build a Vert.x Web from an OpenAPI 3 contract.

  The router is mounting its handlers in the following order:
  1. RootHandler
  in the order the root handlers were added to the RouterBuilder.
  2. ValidationHandler
  This handler is implementing the marker interface `InputTrustHandler`. Because of this, all handlers of type PLATFORM, SECURITY_POLICY, BODY and AUTHENTICATION must be mounted as root handlers if required.
  3. UserHandler
  The custom user handlers defined in the `OpenAPIRoute` in the same order as they are added to the route.
  4. FailureHandler
  The failure handlers defined in the `OpenAPIRoute` in the same order as they are added to the route.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static io.vertx.lang.rx.TypeArg<RouterBuilder>` | `__TYPE_ARG`
    `static String` | `KEY_META_DATA_OPERATION`
    `static String` | `KEY_META_DATA_VALIDATED_REQUEST`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RouterBuilder(Object delegate)`
    `RouterBuilder(RouterBuilder delegate)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static RouterBuilder` | `create(Vertx vertx, OpenAPIContract contract)` Create a new `RouterBuilder`.
    `static RouterBuilder` | `create(Vertx vertx, OpenAPIContract contract, RequestExtractor extractor)` Create a new `RouterBuilder`.
    `Router` | `createRouter()` Construct a new router based on the related OpenAPI contract.
    `boolean` | `equals(Object o)`
    `RouterBuilder` | `getDelegate()`
    `OpenAPIRoute` | `getRoute(String operationId)` Access to a route defined in the contract with `operationId`
    `List<OpenAPIRoute>` | `getRoutes()`
    `int` | `hashCode()`
    `static RouterBuilder` | `newInstance(RouterBuilder arg)`
    `RouterBuilder` | `rootHandler(Handler<RoutingContext> rootHandler)` Add global handler to be applied prior to being generated.
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<RouterBuilder> __TYPE_ARG

    - #### KEY_META_DATA_OPERATION

          public static final String KEY_META_DATA_OPERATION

      See Also:
        Constant Field Values

    - #### KEY_META_DATA_VALIDATED_REQUEST

          public static final String KEY_META_DATA_VALIDATED_REQUEST

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### RouterBuilder

          public RouterBuilder(RouterBuilder delegate)

    - #### RouterBuilder

          public RouterBuilder(Object delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public RouterBuilder getDelegate()

    - #### create

          public static RouterBuilder create(Vertx vertx,
                                             OpenAPIContract contract)

      Create a new `RouterBuilder`. Like `create(io.vertx.rxjava3.core.Vertx, io.vertx.rxjava3.openapi.contract.OpenAPIContract)` but uses a default implementation for the extractor.
      Parameters:
        `vertx` - the related Vert.x instance
        `contract` - the contract that describes the endpoint
      Returns:
        an instance of `RouterBuilder`

    - #### create

          public static RouterBuilder create(Vertx vertx,
                                             OpenAPIContract contract,
                                             RequestExtractor extractor)

      Create a new `RouterBuilder`.
      Parameters:
        `vertx` - the related Vert.x instance
        `contract` - the contract that describes the endpoint
        `extractor` - the extractor is used to extract and transform the parameters and body of the related request in a format that can be validated by the `RequestValidator`.
      Returns:
        an instance of `RouterBuilder`

    - #### getRoute

          public OpenAPIRoute getRoute(String operationId)

      Access to a route defined in the contract with `operationId`
      Parameters:
        `operationId` - the id of the operation
      Returns:
        the requested route, or null if the passed operationId doesn't exist.

    - #### getRoutes

          public List<OpenAPIRoute> getRoutes()

      Returns:
        all routes defined in the contract

    - #### rootHandler

          public RouterBuilder rootHandler(Handler<RoutingContext> rootHandler)

      Add global handler to be applied prior to being generated.
      Parameters:
        `rootHandler` - the root handler to add
      Returns:
        self

    - #### createRouter

          public Router createRouter()

      Construct a new router based on the related OpenAPI contract.
      Returns:
        a Router based on the related OpenAPI contract.

    - #### newInstance

          public static RouterBuilder newInstance(RouterBuilder arg)

Copyright © 2024 Eclipse. All rights reserved.